;TI-86 animation master viewer
;  by Levi Lansing
;  puzzlesome@hotmail.com
;  http://levi.sardonica.net/
;
;  You may use this source code to learn from (if you can understand it)
;  and you may use pieces of it in your programs if you give me
;  credit first!  If you intend on adding in a viewer of your own
;  to display my compressed animation strings, please notify me first!
;  Thank You!


;sorry about the poor documentation, but i neve even intened to
;distribute this code anyway, so feel priviledged!



#include "ti86asm.inc"

;MACROS<
#define ToWORD(BYTE1, BYTE2)    BYTE2*256+BYTE1
#define OffSet(SCREEN, X, Y)    SCREEN+(Y*16)+X
;>

;CONSTANTS<
#define POP_DE    $D1
#define _user_int_ram    $D2FD
#define progEnd   $D748+2550

_findsym  .EQU  46CBh
_delvar   .EQU  475Fh
_mm_ldir  .equ  52EDh
_memchk   .EQU  46BBh
_mov10toop1 equ   42D7h
_inc_ptr_ahl  equ 4637h
_dec_ptr_ahl  equ 463Bh
_getb_ahl     equ 46C3h

_set_mm_num_bytes .equ  464Fh
;_set_abs_src_addr  .equ  462Fh
_set_abs_dest_addr  .equ  5285h

_ABS_SRC_ADDR equ 0C392h
_ABS_DEST_ADDR  equ 0C395h
_MM_NUM_BYTES equ 0C398h
;>

.org _asm_exec_ram

  nop
  jp ProgStart
  .dw 0
  .dw ShellTitle

ShellTitle:
  .db "Master Animation Viewer",0

ProgStart:

 call _runindicoff
 call _flushallmenus
 call _clrScrn

;reset all temp variables <
 ld de,ABS_POINTER
 xor a
 ld (de),a
 inc de
 ld hl,ABS_POINTER
 ld bc,28
 ldir
;>

  ld hl,($D28D)
  ld de,$0064
  add hl,de
  ld (ABS_MEM_START),hl
  ld de,$8000
  add hl,de
  push hl
  ld (MEM_START),hl   ;where the OPS ends
  ld hl,($D291)       ;Floating Point Stack
  ld de,$7F9C
  and a
  add hl,de
  ld (MEM_END),hl   ;where the FPS ends (where AniStd will start using mem)
  pop de
  and a
  sbc hl,de
  ld (FREE_MEM),hl  ;free space between OPS and FPS
  ld a,14
  sub h
  jp nc,NotEnoughMEM

;Load Interrupt program
 res 2,(iy+$23)   ;turn user int off so it won't get called by
                  ;accident before we're ready
clear_int:    ;I always clear the interrupt for neatness (mainly for debugging)
 ld hl,$d2fd  ;point hl to interrupt RAM
 ld (hl),$5A  ;$5A is the standard checksum for a blank interrupt
 inc hl       ;point hl one byte forward
 ld (hl),0    ;clear the next byte
 ld de,$d2ff  ;point de to the byte after hl
 ld bc,198    ;we have to clear 198 bytes (of 200) since we already did the 1st & 2nd
 ldir       ;clear it out

 ld hl,int              ;hl point to the begining of the program
 ld de,_user_int_ram+1  ;de pionts to where the program is to be loaded
 ld bc,int_end-int      ;bc is the length of the program to be sent
 ldir                   ;copies it

 ld a,(_user_int_ram+1)     ;this sets up checksum byte - 
 ld hl,_user_int_ram+($28*1)  ;we need to add the 1st bite with another one
 add a,(hl)           ;every 40 bytes and store it in the...
 ld hl,_user_int_ram+($28*2)
 add a,(hl)
 ld hl,_user_int_ram+($28*3)
 add a,(hl)
 ld hl,_user_int_ram+($28*4)
 add a,(hl)
 ld hl,_user_int_ram+($28*5)
 add a,(hl)
 ld (_user_int_ram),a     ;first byte of the interrupt area


 ld de,$EE00
 ld hl,$FC00
 ld bc,$400
 ldir                 ;clear screen mem for 4-level grayscale

 ld de,$FC00
 ld hl,TitleDark
; ld bc,$B0
; ldir                ;copy the dark title pic
 call DecompressTitle

 ld de,$EE00
 ld hl,TitleLight
; ld bc,$B0
; ldir                ;copy the light title pic
 call DecompressTitle

 ld de,$3306
 ld (Shades),de
 
 set 2,(iy+$23)       ;turn on the interrupt

;Draw upper black bar<
 ld b,16*7
 ld hl,$FCB0
lineloop0:
 ld (hl),$FF
 inc hl
 djnz lineloop0
;>

 set textInverse,(iy+textflags)
 set textEraseBelow,(iy+textflags)
 ld de, ToWORD(1, 11)               ;works like x,y for the small text
 ld (_penCol),de
 ld hl,UpperBar
 call _vputs
 ld de, ToWORD(70, 11)
 ld (_penCol),de
 call _vputs
 res textInverse,(iy+textflags)
 res textEraseBelow,(iy+textflags)

 ld de, ToWORD(13, 18)
 ld (_penCol),de
 call _vputs              ;"Select File"
 push hl

;Draw line under "Select File"<
 ld b,16
 ld hl,$FD90
lineloop1:
 ld (hl),$FF
 inc hl
 djnz lineloop1
;>

 pop hl
 ld de, ToWORD(59, 18)
 ld (_penCol),de
 ld a,207                 ;char 207= <|
 call _vputmap
 ld de, ToWORD(112, 18)
 ld (_penCol),de
 ld a,5                   ;char 5= |>
 call _vputmap

 ld de, ToWORD(17, 26)
 ld (_penCol),de
 call _vputs              ;"Ver:"
 ld de, ToWORD(61, 26)
 ld (_penCol),de
 call _vputs              ;"Length:"
 ld de, ToWORD(17, 34)
 ld (_penCol),de
 call _vputs              ;"Grays:"
 ld de, ToWORD(61, 34)
 ld (_penCol),de
 call _vputs              ;"Date:"
 ld de, ToWORD(17, 41)
 ld (_penCol),de
 call _vputs              ;"Author:"
 ld de, ToWORD(1, 50)
 ld (_penCol),de
 call _vputs              ;"Description:"

;Draw lower black box<
 ld b,16*7
 ld hl,$FF90
lineloop2:
 ld (hl),$FF
 inc hl
 djnz lineloop2
;>



;make all but the title pic black instead of gray<
 ld de,$EEB0
 ld hl,$FCB0
 ld bc,$0350
 ldir
;>


;search for the first animation data string on the calc









Search:
  ld a,2                ;tell the program we are searching for the 1st time
  ld (RightOrLeft),a

  call _ram_page_7  ;This will load RAM page #7 in the area between $8000 and $BFFF
            ;RAM page 7 contains the VAT (variable allocation table, or something like that)
            ;Here are the addresses of all the variables on the calc stored.
            ;It's written backwards so the first entry is at $BFFF.

  ld hl,$BFFF   ;We want to start searching at the beginning (top/bottom) of the VAT.
  push hl       ;make a copy
  ld bc,($D298) ;$D298 contains the address to the end (bottom/top) of the VAT.
  and a         ;Clear the carry flag
  sbc hl,bc     ;Subtract the bottom from the top to get the length. hl = length of VAT
  ld b,h        ;Copy the result to bc
  ld c,l
  ld (lenVAT),bc  ;save the length of the VAT table
  pop hl          ;retrieve the copy (HL=$BFFF)

SearchLoopA:
  ld a,$0C    ;We are looking for Strings. $0C is the ID byte for Strings.

SearchLoopB:
  cpdr    ;This instruction does this: cp (hl)/dec hl/dec bc, i.e. compares the value pointed to by
          ;hl with 'a' decreases hl and bc. It continues doing this until a=(hl) or bc=0.
  jp po,DoneSearching   ;Parity is odd when bc=0
      ;When we've come this far we have found a string. Now we're going to check whether it's one
      ;of our strings.
  jr DetectAni
  

DoneSearching:
 ld hl,noANIs
 ld de, ToWORD(63, 18)
 ld (_penCol),de
 call _vputs              ;"(none)"

 call SetTHEEND
 call Wait_Key
 jp THEEND



DetectAni:
  ld (searchHL),hl  ;save the values for the next search
  ld (searchBC),bc
  ld ix,StringInfo  ;Point ix to a place where the addresses of the strings are going to be stored
  ;;dec hl          ;point hl to the first byte of the ABS address
  ld e,(hl)         ;Load the LSB of the ABS address to e
  dec hl            ;hl now points to the middle byte in the address
  ld d,(hl)         ;Load it into d
  dec hl            ;hl points to MSB of the address
  ld c,(hl)         ;Load it into c
  ;Now we have the address in cde

  dec hl
  dec hl
  ld b,(hl)
  dec hl
TNameLoop:
  ld a,(hl)
  ld (ix),a
  inc ix
  dec hl
  djnz TNameLoop
  push ix
    ;save the location after then name incase it's an animation...
  xor a
  ld (ix),a
  ld ix,Location  ;abs of string
  ld a,c
  ld (ix),a
  inc ix
  ld a,e          ;reverse the d and the e to store as a word
  ld (ix),a
  inc ix
  ld a,d
  ld (ix),a
    ;test to see if it is an animation...
  pop ix
  dec ix
  ld a,(ix)
  cp 'T'
  jr nz,NotOldDAT
  dec ix
  ld a,(ix)
  cp 'A'
  jr nz,NotOldDAT
  dec ix
  ld a,(ix)
  cp 'D'
  jr nz,NotOldDAT
;we think it is the old DAT file for animations, but
;there is no identifier in the string so we much check
;to see if the first two bytes would allow it to be an animation
;(still not 100% safe)
; the rom routines use ahl so...
  ld a,c
  ex de,hl            ;exchange de and hl. AHL = address to the string variable
  call _inc_ptr_ahl   ;Skip the sign bytes of the string
  call _inc_ptr_ahl
  ;push hl
  call _get_word_ahl  ;get first 2 bytes and inc ahl by 2
  ld a,c
  call _dec_ptr_ahl   ;return AHL to beginning
  call _dec_ptr_ahl
  ld a,e
;  6,8,14,32
  cp 6
  jr z,OKani
  cp 8
  jr z,OKani
  cp 14
  jr z,OKani
  cp 32
  jr nz,NotOldDAT2
OKani:
  ld a,1
  cp d
  jp c,notANIstring
;through this simple testing, the string SHOULD be an animation
;so we will display the info for an old animation
  jp dispOldANI
  
NotOldDAT:
; the rom routines use ahl so...
  ld a,c
  ex de,hl            ;exchange de and hl. AHL = address to the string variable
  call _inc_ptr_ahl   ;Skip the sign bytes of the string
  call _inc_ptr_ahl
NotOldDAT2:
  ld a,c
  call _get_word_ahl
  ld a,'A'
  cp e
  jp nz,notANIstring
  ld a,'S'
  cp d
  jp nz,notANIstring
  ld a,c
  call _get_word_ahl
  ld a,'8'
  cp e
  jp nz,notANIstring
  ld a,'6'
  cp d
  jp nz,notANIstring

;The string is an animation, now we update the screen
 push hl
 push bc
 call clearInfo

 ld hl,StringInfo
 ld de, ToWORD(63, 18)
 ld (_penCol),de
 call _vputs              ;name of animation string

;Copy first 1KB of animation string(to get the header)<
 pop bc
 pop hl                   ;get abs to string
 ld a,c
 call _set_abs_src_addr
 ld hl,StringInfo+10
 xor a
 call _set_abs_dest_addr
 ld hl,1024
 xor a
 call _set_mm_num_bytes
 call _mm_ldir
;>

 ld hl,StringInfo+10
 inc hl
 inc hl                   ;skip unimportant stuff
 ld de, ToWORD(33, 26)
 ld (_penCol),de
 call _vputs              ;the version
 ld a,(hl)
 ld (Version),a           ;store version (as byte)
 inc hl
 ld de, ToWORD(88, 26)
 ld (_penCol),de
 call _vputs              ;the length 
 push hl
 ld a,'s'
 call _vputmap
 pop hl
 ld a,(hl)
 inc hl
 push hl
 ld de, ToWORD(40, 34)
 ld (_penCol),de
 call getGrays
 ld a,d
 push de
 call _vputmap              ;the # of colors
 pop de
 ld a,e
 call _vputmap              ;the # of colors
 pop hl

 ld de, ToWORD(80, 34)
 ld (_penCol),de
 call _vputs              ;the date
 ld de, ToWORD(48, 41)
 ld (_penCol),de
 call _vputs              ;the author

 set textInverse,(iy+textflags)
 set textEraseBelow,(iy+textflags)
 ld de, ToWORD(1, 57)
 ld (_penCol),de
 call _vputs              ;the description
 res textInverse,(iy+textflags)
 res textEraseBelow,(iy+textflags)

 jp MenuKeys


dispOldANI:
 call clearInfo
 ld hl,StringInfo
 ld de, ToWORD(63, 18)
 ld (_penCol),de
 call _vputs              ;name of animation string
 ld hl,OLDtxt
 ld de, ToWORD(33, 26)
 ld (_penCol),de
 call _vputs              ;version
 xor a
 ld (Version),a
 jp MenuKeys


clearInfo:
  ld hl, OffSet($FC00, 8, 19)   ;MACRO: calc offset
  ld de, ToWORD(6, 5)
  ld c,0
  call FillRect                 ;clear name
  ld hl, OffSet($FC00, 4, 27)   ;MACRO: calc offset
  ld de, ToWORD(3, 5)
  ld c,0
  call FillRect                 ;clear ver
  ld hl, OffSet($FC00, 11, 27)    ;MACRO: calc offset
  ld de, ToWORD(5, 5)
  ld c,0
  call FillRect                 ;clear ;length
  ld hl, OffSet($FC00, 5, 35)   ;MACRO: calc offset
  ld de, ToWORD(2, 5)
  ld c,0
  call FillRect                 ;clear grays
  ld hl, OffSet($FC00, 10, 35)    ;MACRO: calc offset
  ld de, ToWORD(5, 5)
  ld c,0
  call FillRect                 ;clear date
  ld hl, OffSet($FC00, 6, 42)   ;MACRO: calc offset
  ld de, ToWORD(10, 5)
  ld c,0
  call FillRect                 ;clear author
  ld hl, OffSet($FC00, 0, 57)   ;MACRO: calc offset
  ld de, ToWORD(16, 7)
  ld c,$FF
  call FillRect                 ;clear description


  ret


;input hl=starting byte; e=width (by byte); d=height; c=fill value
;output   destroyed: a, hl, bc, de
FillRect:
  ld b,d
  ld d,c
LoopY:
  push bc
  ld b,e
LoopX:
  ld (hl),d
  inc hl
  djnz LoopX
  ld a,16
  sub e
  ld c,a
  and a
  adc hl,bc
  pop bc
  djnz LoopY
  ret



SearchR:
  ld a,0                ;tell the program we are searching to the right
  ld (RightOrLeft),a
  call _ram_page_7  ;This will load RAM page #7 in the area between $8000 and $BFFF
                    ;RAM page 7 contains the VAT (variable allocation table, or something like that)
                    ;Here are the addresses of all the variables on the calc stored.
                    ;It's written backwards so the first entry is at $BFFF.
  ld hl,(searchBC)
;skip the location bytes and put result in bc<
  ld de,2
  and a
  sbc hl,de
  ld b,h
  ld c,l
;>
  ld hl,(searchHL)
;skip the location bytes <
  and a
  sbc hl,de
;>
SearchLoopAR:
  ld a,$0C    ;We are looking for Strings. $0C is the ID byte for Strings.
SearchLoopBR:
  cpdr              ;This instruction does this: cp (hl)/dec hl/dec bc, i.e. compares the value pointed to by
                    ;hl with 'a' decreases hl and bc. It continues doing this until a=(hl) or bc=0.
  jp po,endofVATR   ;Parity is odd when bc=0

    ;we have found a string. lets see if it's an animation
  jp DetectAni
endofVATR:
  ld hl,$BFFF     ;We want to start searching at the beginning (top/bottom) of the VAT.
  ld bc,(lenVAT)  ;get the length of the VAT table
  jr SearchLoopAR



SearchL:
  ld a,1            ;tell the program we are searching to the left
  ld (RightOrLeft),a
  call _ram_page_7  ;This will load RAM page #7 in the area between $8000 and $BFFF
                    ;RAM page 7 contains the VAT (variable allocation table, or something like that)
                    ;Here are the addresses of all the variables on the calc stored.
                    ;It's written backwards so the first entry is at $BFFF.

  ld bc,(searchBC)
;reverse the search counter to go backwards
  ld hl,(lenVAT)
  sbc hl,bc
  ld b,h
  ld c,l
;>
  ld hl,(searchHL)
;skip the current identifier <
  inc hl
  inc hl
  dec bc
  dec bc
;>
SearchLoopAL:
  ld a,$0C      ;We are looking for Strings. $0C is the ID byte for Strings.
SearchLoopBL:
  cpir              ;This instruction does this: cp (hl)/inc hl/dec bc, i.e. compares the value pointed to by
                    ;hl with 'a' inc hl and bc. It continues doing this until a=(hl) or bc=0.
  jp po,endofVATL   ;Parity is odd when bc=0

  dec hl        ;after cpir, hl points one byte after the $0C,
  dec hl        ;but the detection routine needs it to point 1 byte before it
  inc bc
  inc bc
  push hl
  dec hl
  dec hl
  dec hl
  xor a
  cp (hl)
  jr nz,FalseAlarmL
;reverse the search counter to go forwards
  ld hl,(lenVAT)
  sbc hl,bc
  ld b,h
  ld c,l
;>
  pop hl
    ;we have found a string. lets see if it's an animation
  jp DetectAni
endofVATL:
                    ;We want to start searching at the end (top/bottom) of the VAT.
  ld hl,($D298)     ;$D298 contains the address to the end (bottom/top) of the VAT.
  ld bc,(lenVAT)    ;get the length of the VAT table
  jr SearchLoopAL

FalseAlarmL:
  pop hl
  jr SearchLoopBL




notANIstring:
  ld a,(RightOrLeft)
  cp 1
  jr z,SearchL
  cp 0
  jr z,SearchR
  call _ram_page_7  ;load ram page 7
  ld hl,(searchBC)
;skip the location bytes and put result in bc<
  ld de,2
  and a
  sbc hl,de
  ld b,h
  ld c,l
;>
  ld hl,(searchHL)
;skip the location bytes <
  and a
  sbc hl,de
;>
  jp SearchLoopA    ;continue searching for the first time






OLDtxt:
  .db "Old",0


MenuKeys:
 halt
 halt
 call _getky
 cp K_EXIT
 jp z,THEEND
 cp K_PLUS
 push af
 call z,ContrastU
 pop af
 jr z,MenuKeys
 cp K_MINUS
 push af
 call z,ContrastD
 pop af
 cp K_RIGHT
 jp z,SearchR
 cp K_LEFT
 jp z,SearchL
 cp K_ENTER
 jp z,RunAnimation
 jr MenuKeys













                ;**changes the exit jump in the Wait_Key loop
SetTHEEND:      ;to safely exit when called outside an animation
 ld de,THEEND
 ld (ExitTo+1),de
 ld a,$00       ;$00 = " nop"
 ld (popde),a
 ret

                ;**changes the exit jump in the Wait_Key loop
SetAPExit:      ;to safely exit in the middle of an animation
 ld de,APExit
 ld (ExitTo+1),de
 ld a,POP_DE    ;POP_DE = $D1 = " pop de"
 ld (popde),a
 ret


;SIMPLE RLE decompressor (decompresses $B0 bytes)
;$B7 is the marker, the following # is the # of 0's minus 1
;input - hl=compressed data, de = where to output
DecompressTitle:
 ld c,0
DTnext:
 ld a,(hl)
 cp $b7
 jr nz,straight
 inc hl
 ld b,(hl)
DTloop:
 inc de
 inc c
 djnz DTloop
 xor a
straight:
 ld (de),a
cont:
 inc hl
 inc de
 inc c
 ld a,$B0
 cp c
 ret z
 jr DTnext


RunAnimation:
  call _clrScrn
 ld de,$EE01
 ld hl,$EE00
 ld (hl),0
 ld bc,$0BFF
 ldir
 ld de,$CA01
 ld hl,$CA00
 ld (hl),0
 ld bc,$03FF
 ldir
  call SetAPExit
RepeatAnimation:
  ld a,(Location)
  ld hl,(Location+1)
 ld c,a
 push af
 call _get_word_ahl
 ld (ANIsize),de
 ld a,(Version)
 cp 1
 jr nz,OLDver
 pop af
 call _get_word_ahl
 ld a,c
 call _get_word_ahl
 ld a,c
 call _get_word_ahl
 ld a,c
 push af
 push de
 inc de
 inc de
 inc de
 inc de
 inc de
 inc de
 ld (ByteCount),de
 pop de
 add hl,de
 adc a,0
OLDver:
 pop af
 ;ld a,c
 ld (ABS_STRING_ADDR),a
 ld (ABS_STRING_ADDR+1),hl
 ld (ABS_POINTER),a
 ld (ABS_POINTER+1),hl
 call _set_abs_src_addr
 ld hl,(ABS_MEM_START)
 ;call _dec_ptr_ahl
 ;dec hl
 ld a,1
 call _set_abs_dest_addr
 ld hl,5128
 xor a
 call _set_mm_num_bytes
 call _mm_ldir

;interrupt program was loaded here**

 call _ram_page_1
 ld de,(MEM_START)
 ld a,(de)
 inc de
 push de
 ld (Shades),a
 call getGrays        ;get the offset for the screen mem table in c
 pop de
 ld a,c
 ld (Shades+1),a
 set 2,(iy+$23)       ;turn on the interrupt
 jr FirstFrame

;StartAgain:
; ld de,TI866_1
; ld b,46
; push bc
LOOP:
 call _ram_page_1
 ld de,(MEM_START)
FirstFrame:
 ld hl,$FC00
 ld a,(de)
 inc de
 cp 4
 jp z,RepeatAnimation
 cp 0
 jr nz,noCopyPic1
 ld bc,1024
 ex de,hl
 ldir
 ex de,hl
 jr next1
noCopyPic1:
 cp 1
 push af
 call z,decompVo
 pop af
 call nz,decompV    ;hl still = $CA
next1:
 call ContrastU
 ld hl,$EE00
 ld a,(de)
 inc de
 cp 0
 jr  nz,noCopyPic2
 ld bc,1024
 ex de,hl
 ldir
 ex de,hl
 jr next2
noCopyPic2
 cp 1
 push af
 call z,decompVo
 pop af
 jr z,next2
 cp 2
 jr nz,nocpy1
 push bc
 push hl
 push de
 ld hl,$FC00
 ld de,$EE00
 ld bc,1024
 ldir
 pop de
 pop hl
 pop bc
 call decompV
 jr next2
nocpy1:
 call decompV
next2:
 ld a,(Shades)
 cp 8
 jr c,next3
 ld hl,$F200
 ld a,(de)
 inc de
 cp 0
 jr  nz,noCopyPic3
 ld bc,1024
 ex de,hl
 ldir
 ex de,hl
 jr next3
noCopyPic3
 cp 1
 push af
 call z,decompVo
 pop af
 jr z,next3
 cp 2
 jr nz,nocpy2
 push bc
 push hl
 push de
 ld hl,$EE00
 ld de,$F200
 ld bc,1024
 ldir
 pop de
 pop hl
 pop bc
 call decompV
 jr next3
nocpy2:
 call decompV
next3:
 ld a,(Shades)
 cp 14
 jr c,next4
 ld hl,$F600
 ld a,(de)
 inc de
 cp 0
 jr  nz,noCopyPic4
 ld bc,1024
 ex de,hl
 ldir
 ex de,hl
 jr next4
noCopyPic4
 cp 1
 push af
 call z,decompVo
 pop af
 jr z,next4
 cp 2
 jr nz,nocpy3
 push bc
 push hl
 push de
 ld hl,$F200
 ld de,$F600
 ld bc,1024
 ldir
 pop de
 pop hl
 pop bc
 call decompV
 jr next4
nocpy3:
 call decompV
next4:
 call ContrastD
 ld a,(Shades)
 cp 32
 jr c,next5
 ld hl,$CA00
 ld a,(de)
 inc de
 cp 0
 jr  nz,noCopyPic5
 ld bc,1024
 ex de,hl
 ldir
 ex de,hl
 jr next5
noCopyPic5
 cp 1
 push af
 call z,decompVo
 pop af
 jr z,next5
 cp 2
 jr nz,nocpy4
 push bc
 push hl
 push de
 ld hl,$F600
 ld de,$CA00
 ld bc,1024
 ldir
 pop de
 pop hl
 pop bc
 call decompV
 jr next5
nocpy4:
 call decompV
next5:
 call Delay
; jp z,THEEND
 ld hl,(MEM_START)
 ex de,hl
 and a
 sbc hl,de
; push hl
; pop bc
 ld c,l
 ld b,h

;check to see if we're at the end of the animation or not<
 ld hl,(ByteCount)
 and a
 adc hl,bc
 ld de,(ANIsize)
 ld a,d
 cp h
 jp c,THEEND
 jp nz,NotEnd
 ld a,e
 cp l
 jp c,THEEND
 jp z,THEEND
;>

NotEnd:
 ld (ByteCount),hl

 ld hl,(ABS_STRING_ADDR+1)
 ld a,(ABS_STRING_ADDR)
;add bc to ahl<
 add hl,bc
 adc a,0
;>

 ld (ABS_STRING_ADDR),a
 ld (ABS_STRING_ADDR+1),hl

 call _set_abs_src_addr
 ld hl,(ABS_MEM_START)
 ld a,1
 call _set_abs_dest_addr

 ld de,(ByteCount)
 ld hl,(ANIsize)
 and a
 sbc hl,de
 ld de,5127
 ld a,h
 cp d
 jr z,DHeq
 jr c,DHok
 jr DHnotok 
DHeq:
  ld a,l
  cp e
  jr c,DHok
DHnotok:
  ex de,hl
DHok:
 xor a
 call _set_mm_num_bytes
 call _mm_ldir
 jp LOOP




int:
 push af
 push hl
 push bc
 ld hl,counter
 dec (hl)
 jr nz,EndIntRoutine
 ld (hl),2
 ld hl,Shades
 ld b,(hl)
 inc hl
 ld c,(hl)
 ld hl,page_number
 ld a,(hl)
 cp b
 jr c,keepgoing
 ld (hl),1
keepgoing:
 ld a,(hl)
 add a,c
 ld b,a
 inc (hl)
findpage:
 inc hl
 djnz findpage
 ld a,(Last)
 cp (hl)
 jr z,EndIntRoutine
 ld a,(hl)
 out (0),a
 ld (Last),a
EndIntRoutine:
 pop bc
 pop hl
 pop af
 ret
int_end:

cnt2:
  .db 1
Last:
  .db 0
counter2:
  .db 0,0,0
counter:
  .db 2

page_number:
  .db 1
page_order:

;gray 32 (use 32)
  .db $2E,$3C,$3C,$32,$3C,$2E,$36,$3C,$2E,$3C,$3C,$32
  .db $2E,$3C,$0A,$3C,$3C,$2E,$32,$3C,$2E,$3C,$3C,$2E
  .db $36,$3C,$3C,$32,$2E,$3C,$3C

;gray 16 (use 14)
  .db $3C,$2E,$3C,$32,$3C,$36,$3C,$2E,$3C,$32,$3C,$2E,$3C

;gray 8 (use 8)
  .db $3C,$2E,$3C,$32,$3C,$2E,$3C

;gray 4 (use 6)
  .db $3C,$3C,$2E,$2E,$3C,$3C


getGrays:
 cp 32
 jr nz,Gnot32
 ld c,0
 ld d,'3'
 ld e,'2'
Gnot32:
 cp 14
 jr nz,Gnot16
 ld c,31
 ld d,'1'
 ld e,'6'
Gnot16:
 cp 8
 jr nz,Gnot8
 ld c,44
 ld d,'8'
 ld e,' '
Gnot8:
 cp 6
 ret nz
 ld c,51
 ld d,'4'
 ld e,' '
 ret


Delay:
 ld a,(de)
 ld b,a
 inc de
 ld a,(de)
 ld c,a
 inc de
 push de
 ld a,b
 or c
 cp 0
 jr z,Wait_Key
DelayBC:
  halt
skp:
  push bc
  call _getky
  pop bc
  cp K_EXIT
  jr z,APExit
  cp K_PLUS
  push af
  call z,ContrastU
  pop af
  cp K_MINUS
  push af
  call z,ContrastD
  pop af
  cp K_ENTER
  jr z,Wait_Key
  dec bc
  xor a
  cp b
  jr nz,DelayBC
  cp c
  jr nz,DelayBC
 pop de
 ret

ContrastU:
 ld a,($C008) ; load contrast value
 inc a        ; increase the contrast
 cp 31        ; check if it's at the max
 ret z        ; return if it is
 ld ($C008),a ; write it back to memory
 out (2),a    ; and to the port
 ret

ContrastD:
 ld a,($C008)   ; load contrast value
 dec a          ; decrease the contrast
 cp 0           ; check if it's at the min
 ret z          ; return if it is
 ld ($C008),a   ; write it back to memory
 out (2),a      ; and to the port
 ret

Wait_Key:
 halt
 halt
 call _getky
 cp K_EXIT
ExitTo:           ;this label is used to change the point of exit
 jp z,APExit
 cp K_PLUS
 push af
 call z,ContrastU
 pop af
 jr z,Wait_Key
 cp K_MINUS
 push af
 call z,ContrastD
 pop af
 jr z,Wait_Key
 cp 0
 jr z,Wait_Key
popde:            ;label used to change between "pop de" and "nop"
 pop de
 ret

APExit:
 pop de
 pop de           ;remove the call from the stack
;; pop bc         ;from first routine
THEEND:
 res 2,(iy+$23)   ;turn user int off
 ld a,$3C
 out (0),a
 call _clrScrn
 ret              ;return from program


NotEnoughMEM:
  call _homeup
  ld hl,NEMEM
  call _puts
  ret
;noexist:
; call _homeup
; ld hl,NOEXIST
; call _puts
; ret


;input- hl=location to clear
ClearHL:
  push de
  push hl
  ld d,h
  ld e,l
  inc de
  ld (hl),0
  ld bc,$03FF
  ldir
  pop hl
  pop de
  ret



;********************************************************
; -decompresses data that is vertically compressed with
; bmp2asm, by Levi Lansing    (total size=66 bytes)
; -(decompresses data xors w/the video mem - 1024 bytes)
; -h=location to decompress ($XX00 where XX is h)
; -de=location of data to decompress
; -destroys- a,b,c,hl,de (points to byte after data)
;********************************************************
decompV:
 ld a,4
 add a,h
 ld (toofar),a
 ld l,0         ;makes hl = $XX00
 jr DecompVstart
DVloopDE:       ;loop to here
 pop de
 inc de
DecompVstart:     ;start here
 ld a,(de)
 cp $B7
 jr z,extract
 xor (hl)
 ld (hl),a
 push de
 ld de,16
 add hl,de
 ld a,(toofar)
 cp h
 jr nz,DVloopDE
 ld de,1023
 and a
 sbc hl,de
 ld a,16
 cp l
 jr z,DoneV
 jr DVloopDE

extract:
 inc de
 ld a,(de)
 ld c,a
 inc de
 ld a,(de)
 ld b,a
 push de
exLoop:
 ld de,16
 ld a,c
 xor (hl)
 ld (hl),a
 add hl,de
 ld a,(toofar)
 cp h
 jr nz,contEX
 ld de,1023
 and a
 sbc hl,de
 ld a,16
 cp l
 jr z,DoneV
contEX:
 djnz exLoop
 jr DVloopDE

DoneV:
 pop de
 inc de
 ret

toofar:
  .db 0



;********************************************************
; -decompresses data that is vertically compressed with
; bmp2asm, by Levi Lansing    (total size=66 bytes)
; -(decompresses data overwrites the vid mem- 1024 bytes)
; -h=location to decompress ($XX00 where XX is h)
; -de=location of data to decompress
; -destroys- a,b,c,hl,de (points to byte after data)
;********************************************************
decompVo:
 ld a,4
 add a,h
 ld (toofar),a
 ld l,0         ;makes hl = $XX00
 jr DecompVstarto
DVloopDEo:        ;loop to here
 pop de
 inc de
DecompVstarto:      ;start here
 ld a,(de)
 cp $B7
 jr z,extracto
 ld (hl),a
 push de
 ld de,16
 add hl,de
 ld a,(toofar)
 cp h
 jr nz,DVloopDEo
 ld de,1023
 and a
 sbc hl,de
 ld a,16
 cp l
 jr z,DoneV
 jr DVloopDEo

extracto:
 inc de
 ld a,(de)
 ld c,a
 inc de
 ld a,(de)
 ld b,a
 push de
exLoopo:
 ld de,16
 ld a,c
 ld (hl),a
 add hl,de
 ld a,(toofar)
 cp h
 jr nz,contEXo
 ld de,1023
 and a
 sbc hl,de
 ld a,16
 cp l
 jr z,DoneV
contEXo:
 djnz exLoopo
 jr DVloopDEo

ABS_POINTER       equ progEnd
; .db 0
; .dw 0
ABS_STRING_ADDR   equ progEnd+3
; .db 0
; .dw 0
MEM_START         equ progEnd+6
; .dw 0
ABS_MEM_START     equ progEnd+8
; .dw 0
MEM_END           equ progEnd+10
; .dw 0
FREE_MEM          equ progEnd+12
; .dw 0
ByteCount         equ progEnd+14
; .dw 0
NIsize            equ progEnd+16
; .dw 0
Shades            equ progEnd+18
; .db 0
; .db 0
searchHL          equ progEnd+20
;  .dw 0
searchBC          equ progEnd+22
; .dw 0
lenVAT            equ progEnd+24
; .dw 0
Location          equ progEnd+26
; .db 0
; .dw 0
RightOrLeft       equ progEnd+29
; .db 0
Version           equ progEnd+30
; .db 0
ANIsize           equ progEnd+31
;  .dw 0
StringInfo        equ progEnd+33
; .db 0

NEMEM:
  .db " -RAM PAGE 1 is FULL-"
  .db "Exit shells or reset "
  .db "calc to correct",0
noANIs:
  .db "(none)",0
UpperBar:
  .db "Viewer v1.0",0
  .db "By  Levi  Lansing",0
  .db "Select  File",0
  .db "Ver:",0
  .db "Length:",0
  .db "Grays:",0
  .db "Date:",0
  .db "Author:",0
  .db "Description:",0



;TitleDark:
;  .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$70,$00,$03,$00,$00,$3C,$0C
;  .db $00,$00,$00,$00,$00,$08,$80,$00,$00,$E0,$80,$03,$10,$00,$62,$18
;  .db $00,$00,$00,$00,$00,$F9,$00,$00,$01,$1F,$80,$06,$30,$00,$46,$30
;  .db $00,$00,$00,$00,$00,$10,$00,$00,$03,$03,$00,$06,$00,$00,$46,$60
;  .db $00,$00,$00,$00,$08,$30,$0C,$10,$01,$83,$10,$1C,$01,$C0,$6C,$60
;  .db $00,$00,$00,$10,$10,$21,$1F,$32,$00,$C6,$32,$3C,$63,$E0,$78,$D8
;  .db $00,$00,$00,$01,$04,$23,$12,$7E,$40,$6E,$26,$7C,$67,$40,$38,$CC
;  .db $00,$00,$00,$00,$22,$21,$92,$31,$80,$36,$3F,$77,$3E,$C0,$7C,$CC
;  .db $00,$00,$00,$00,$00,$30,$18,$20,$00,$E7,$30,$C0,$13,$00,$6C,$46
;  .db $00,$00,$00,$00,$00,$00,$00,$00,$03,$80,$00,$00,$00,$00,$78,$7C
;  .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$30,$1C

;TitleLight:
;  .db $00,$00,$00,$00,$00,$00,$00,$00,$00,$10,$00,$03,$00,$00,$3E,$0E
;  .db $03,$00,$08,$00,$00,$00,$00,$00,$01,$B1,$00,$02,$30,$00,$76,$1C
;  .db $09,$00,$18,$00,$00,$00,$80,$00,$03,$CF,$80,$02,$20,$00,$02,$30
;  .db $01,$00,$00,$00,$06,$28,$00,$00,$01,$8D,$00,$0C,$00,$00,$C6,$70
;  .db $11,$08,$00,$58,$04,$00,$02,$20,$03,$86,$30,$0C,$01,$80,$CE,$F0
;  .db $17,$38,$11,$EA,$0E,$52,$08,$74,$01,$87,$24,$24,$23,$C0,$3C,$F0
;  .db $01,$57,$19,$DE,$3A,$40,$A9,$83,$80,$F2,$76,$67,$72,$60,$38,$98
;  .db $21,$19,$99,$99,$50,$40,$65,$8B,$00,$62,$AA,$E2,$63,$80,$28,$06
;  .db $01,$10,$00,$10,$20,$40,$80,$00,$01,$42,$30,$60,$27,$80,$44,$6C
;  .db $00,$00,$00,$00,$00,$20,$00,$00,$01,$46,$00,$00,$00,$00,$D8,$3E
;  .db $00,$00,$00,$00,$00,$00,$00,$00,$01,$80,$00,$00,$00,$00,$48,$20


;title images have been compressed with simple RLE compression (by hand)
;$B7 is the marker, and the following # is the # of 0's minus 1

TitleDark:
  .db $B7,$08,$70,$00,$03,$00,$00,$3C,$0C
  .db $B7,$04,$08,$80,$00,$00,$E0,$80,$03,$10,$00,$62,$18
  .db $B7,$04,$F9,$00,$00,$01,$1F,$80,$06,$30,$00,$46,$30
  .db $B7,$04,$10,$00,$00,$03,$03,$00,$06,$00,$00,$46,$60
  .db $B7,$03,$08,$30,$0C,$10,$01,$83,$10,$1C,$01,$C0,$6C,$60
  .db $B7,$02,$10,$10,$21,$1F,$32,$00,$C6,$32,$3C,$63,$E0,$78,$D8
  .db $B7,$02,$01,$04,$23,$12,$7E,$40,$6E,$26,$7C,$67,$40,$38,$CC
  .db $B7,$03,$22,$21,$92,$31,$80,$36,$3F,$77,$3E,$C0,$7C,$CC
  .db $B7,$04,$30,$18,$20,$00,$E7,$30,$C0,$13,$00,$6C,$46
  .db $B7,$07,$03,$80,$B7,$03,$78,$7C
  .db $B7,$0D,$30,$1C

TitleLight:
  .db $B7,$08,$10,$00,$03,$00,$00,$3E,$0E
  .db $03,$00,$08,$B7,$04,$01,$B1,$00,$02,$30,$00,$76,$1C
  .db $09,$00,$18,$B7,$02,$80,$00,$03,$CF,$80,$02,$20,$00,$02,$30
  .db $01,$B7,$02,$06,$28,$00,$00,$01,$8D,$00,$0C,$00,$00,$C6,$70
  .db $11,$08,$00,$58,$04,$00,$02,$20,$03,$86,$30,$0C,$01,$80,$CE,$F0
  .db $17,$38,$11,$EA,$0E,$52,$08,$74,$01,$87,$24,$24,$23,$C0,$3C,$F0
  .db $01,$57,$19,$DE,$3A,$40,$A9,$83,$80,$F2,$76,$67,$72,$60,$38,$98
  .db $21,$19,$99,$99,$50,$40,$65,$8B,$00,$62,$AA,$E2,$63,$80,$28,$06
  .db $01,$10,$00,$10,$20,$40,$80,$00,$01,$42,$30,$60,$27,$80,$44,$6C
  .db $B7,$04,$20,$00,$00,$01,$46,$B7,$03,$D8,$3E
  .db $B7,$07,$01,$80,$B7,$03,$48,$20

EndOfProg:
.end
